## donut-shellcode 0.9.3+git20220530.e75bdcd

=== Makefile ===
donut: clean
	gcc -Wunused-function -Wall -fpack-struct=8 -DDONUT_EXE -I include donut.c hash.c encrypt.c format.c loader/clib.c -odonut lib/aplib64.a
	gcc -Wunused-function -Wall -c -fpack-struct=8 -fPIC -I include donut.c hash.c encrypt.c format.c loader/clib.c 
	ar rcs lib/libdonut.a donut.o hash.o encrypt.o format.o clib.o lib/aplib64.a
	gcc -Wall -shared -o lib/libdonut.so donut.o hash.o encrypt.o format.o clib.o lib/aplib64.a
debug: clean
	gcc -Wunused-function -ggdb -Wall -Wno-format -fpack-struct=8 -DDEBUG -DDONUT_EXE -I include donut.c hash.c encrypt.c format.c loader/clib.c lib/aplib64.a -odonut
hash:
	gcc -Wall -Wno-format -fpack-struct=8 -DTEST -I include hash.c loader/clib.c -ohash
encrypt:
	gcc -Wall -Wno-format -fpack-struct=8 -DTEST -I include encrypt.c loader/clib.c -oencrypt
clean:
	rm -f loader.exe exe2h.exe exe2h loader32.exe loader64.exe donut.o hash.o encrypt.o format.o clib.o hash encrypt donut hash.exe encrypt.exe donut.exe lib/libdonut.a lib/libdonut.so inject32.exe inject64.exe inject_local32.exe inject_local64.exe

=== debian/changelog ===
donut-shellcode (0.9.3+git20220530.e75bdcd-0parrot2) lory-updates; urgency=medium

  * Fix control file.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Sat, 02 Dec 2023 01:51:26 +0100

donut-shellcode (0.9.3+git20220530.e75bdcd-0parrot1) lory; urgency=medium

  * Rebuild for Parrot 6.0.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Thu, 07 Sep 2023 00:45:33 +0200

donut-shellcode (0.9.3+git20220530.e75bdcd-0kali2) kali-dev; urgency=medium

  * Do not build with aPLib: the build uses binary files only available for
    i386 and amd64

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 13 Jun 2022 16:18:59 +0200

donut-shellcode (0.9.3+git20220530.e75bdcd-0kali1) kali-dev; urgency=medium

  [ Kali Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Ben Wilson ]
  * Remove template comment and switch spaces to tabs

  [ Sophie Brun ]
  * New upstream version 0.9.3+git20220530.e75bdcd from repo
    https://github.com/BC-SECURITY/donut to get a fix for Python 3.10. Do not
    change the upstream repo for the moment.

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 13 Jun 2022 12:20:29 +0200

donut-shellcode (0.9.2-0kali1) kali-dev; urgency=medium

  * Initial release

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 26 Mar 2020 17:33:15 +0100

=== debian/control ===
Source: donut-shellcode
Section: python
Priority: optional
Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Build-Depends: debhelper-compat (= 12), dh-python, python3-setuptools, python3-all-dev
Standards-Version: 4.6.1
Homepage: https://github.com/TheWover/donut
Testsuite: autopkgtest-pkg-python

Package: python3-donut
Architecture: any
Depends: ${python3:Depends}, ${misc:Depends}, ${shlibs:Depends}
Suggests: python-donut-doc
Description: Generates position-independent shellcode from memory and runs them
 Donut is a position-independent code that enables in-memory execution of
 VBScript, JScript, EXE, DLL files and dotNET assemblies. A module created by
 Donut can either be staged from a HTTP server or embedded directly in the
 loader itself. The module is optionally encrypted using the Chaskey block
 cipher and a 128-bit randomly generated key. After the file is loaded and
 executed in memory, the original reference is erased to deter memory scanners.
 The generator and loader support the following features:
    - Compression of input files with aPLib and LZNT1, Xpress, Xpress Huffman
      via RtlCompressBuffer.
    - Using entropy for API hashes and generation of strings.
    - 128-bit symmetric encryption of files.
    - Patching Antimalware Scan Interface (AMSI) and Windows Lockdown Policy
      (WLDP).
    - Patching command line for EXE files.
    - Patching exit-related API to avoid termination of host process.
    - Multiple output formats: C, Ruby, Python, PowerShell, Base64, C#,
      Hexadecimal.
 .
 This package installs the Python 3 module.

Package: python-donut-doc
Architecture: all
Section: doc
Depends: ${sphinxdoc:Depends}, ${misc:Depends}
Description: Donut documentation
 Donut is a position-independent code that enables in-memory execution of
 VBScript, JScript, EXE, DLL files and dotNET assemblies. A module created by
 Donut can either be staged from a HTTP server or embedded directly in the
 loader itself. The module is optionally encrypted using the Chaskey block
 cipher and a 128-bit randomly generated key. After the file is loaded and
 executed in memory, the original reference is erased to deter memory scanners.
 The generator and loader support the following features:
    - Compression of input files with aPLib and LZNT1, Xpress, Xpress Huffman
      via RtlCompressBuffer.
    - Using entropy for API hashes and generation of strings.
    - 128-bit symmetric encryption of files.
    - Patching Antimalware Scan Interface (AMSI) and Windows Lockdown Policy
      (WLDP).
    - Patching command line for EXE files.
    - Patching exit-related API to avoid termination of host process.
    - Multiple output formats: C, Ruby, Python, PowerShell, Base64, C#,
      Hexadecimal.
 .
 This is the common documentation package.

=== debian/rules ===
#!/usr/bin/make -f

# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

export PYBUILD_NAME=donut
export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

%:
	dh $@ --with python3 --buildsystem=pybuild

## donut-shellcode 1.1

=== Makefile ===
donut: clean
	gcc -Wunused-function -Wall -fpack-struct=8 -DDONUT_EXE -I include donut.c hash.c encrypt.c format.c loader/clib.c lib/aplib64.a -odonut 
	gcc -Wunused-function -Wall -c -fpack-struct=8 -fPIC -I include donut.c hash.c encrypt.c format.c loader/clib.c 
	ar rcs lib/libdonut.a donut.o hash.o encrypt.o format.o clib.o lib/aplib64.a
	gcc -Wall -shared -o lib/libdonut.so donut.o hash.o encrypt.o format.o clib.o lib/aplib64.a
debug: clean
	gcc -Wunused-function -ggdb -Wall -Wno-format -fpack-struct=8 -DDEBUG -DDONUT_EXE -I include donut.c hash.c encrypt.c format.c loader/clib.c lib/aplib64.a -odonut
hash:
	gcc -Wall -Wno-format -fpack-struct=8 -DTEST -I include hash.c loader/clib.c -ohash
encrypt:
	gcc -Wall -Wno-format -fpack-struct=8 -DTEST -I include encrypt.c loader/clib.c -oencrypt
inject:
	gcc -Wall -Wno-format -fpack-struct=8 -DTEST -I include loader/inject.c -oinject
inject_local:
	gcc -Wall -Wno-format -fpack-struct=8 -DTEST -I include loader/inject_local.c -oinject_local
clean:
	rm -f loader.exe exe2h.exe exe2h loader32.exe loader64.exe donut.o hash.o encrypt.o format.o clib.o hash encrypt donut hash.exe encrypt.exe donut.exe lib/libdonut.a lib/libdonut.so

=== debian/changelog ===
donut-shellcode (1.1-0kali3) kali-dev; urgency=medium

  * Add donut binary package
  * Add superficial tests
  * Replace donut <=1.1-0kali2

 -- Daniel Ruiz de Alegría <daniruiz@kali.org>  Mon, 10 Mar 2025 16:50:28 +0100

donut-shellcode (1.1-0kali1) kali-dev; urgency=medium

  [ Kali Janitor ]
  * Update standards version to 4.6.2, no changes needed.

  [ Sophie Brun ]
  * New upstream version 1.1
  * Refresh patches
  * Bump Standards-Version to 4.7.0

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 28 Jan 2025 10:47:54 +0100

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,46 @@
 Source: donut-shellcode
 Section: python
 Priority: optional
-Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
-Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
-Build-Depends: debhelper-compat (= 12), dh-python, python3-setuptools, python3-all-dev
-Standards-Version: 4.6.1
+Maintainer: Kali Developers <devel@kali.org>
+Uploaders:
+ Sophie Brun <sophie@offensive-security.com>,
+ Daniel Ruiz de Alegría <daniruiz@kali.org>,
+Build-Depends: debhelper-compat (= 13), dh-python, python3-setuptools, python3-all-dev
+Standards-Version: 4.7.0
 Homepage: https://github.com/TheWover/donut
+Vcs-Browser: https://gitlab.com/kalilinux/packages/donut-shellcode
+Vcs-Git: https://gitlab.com/kalilinux/packages/donut-shellcode.git
 Testsuite: autopkgtest-pkg-python
+
+Package: donut
+Architecture: amd64
+Depends:
+ ${shlibs:Depends},
+ ${misc:Depends},
+Description: Generates position-independent shellcode from memory and runs them
+ Donut is a position-independent code that enables in-memory execution of
+ VBScript, JScript, EXE, DLL files and dotNET assemblies. A module created by
+ Donut can either be staged from a HTTP server or embedded directly in the
+ loader itself. The module is optionally encrypted using the Chaskey block
+ cipher and a 128-bit randomly generated key. After the file is loaded and
+ executed in memory, the original reference is erased to deter memory scanners.
+ The generator and loader support the following features:
+    - Compression of input files with aPLib and LZNT1, Xpress, Xpress Huffman
+      via RtlCompressBuffer.
+    - Using entropy for API hashes and generation of strings.
+    - 128-bit symmetric encryption of files.
+    - Patching Antimalware Scan Interface (AMSI) and Windows Lockdown Policy
+      (WLDP).
+    - Patching command line for EXE files.
+    - Patching exit-related API to avoid termination of host process.
+    - Multiple output formats: C, Ruby, Python, PowerShell, Base64, C#,
+      Hexadecimal.
 
 Package: python3-donut
 Architecture: any
 Depends: ${python3:Depends}, ${misc:Depends}, ${shlibs:Depends}
+Breaks: donut (<=1.1-0kali2)
+Replaces: donut (<=1.1-0kali2)
 Suggests: python-donut-doc
 Description: Generates position-independent shellcode from memory and runs them
  Donut is a position-independent code that enables in-memory execution of

=== debian/rules ===
--- 
+++ 
@@ -8,3 +8,7 @@
 
 %:
 	dh $@ --with python3 --buildsystem=pybuild
+
+override_dh_auto_build:
+	make
+	dh_auto_build

=== debian/tests/control ===
Test-Command: donut -h
Restrictions: superficial

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%donut-shellcode-$1.tar.gz%" \
   https://github.com/TheWover/donut/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
